unit U_MCGRKList_CX;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ToolWin, cxStyles, cxCustomData,
  cxGraphics, cxFilter, cxData, cxDataStorage, cxEdit, DB, cxDBData, ADODB,
  cxGridCustomPopupMenu, cxGridPopupMenu, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, DBClient, cxCheckBox, cxCalendar, cxSplitter,
  RM_Dataset, RM_System, RM_Common, RM_Class, RM_GridReport, RM_e_Xls,
  Menus, cxButtonEdit, cxDropDownEdit, cxPC, Buttons, cxContainer,
  cxGroupBox, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdFTP,ShellAPI, ImgList,StrUtils;

type
  TfrmMCGRKList_CX = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBClose: TToolButton;
    Tv1: TcxGridDBTableView;
    cxGrid1Level1: TcxGridLevel;
    cxGrid1: TcxGrid;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;                  
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    TBExport: TToolButton;
    Order_Main: TClientDataSet;
    ToolButton1: TToolButton;
    Panel1: TPanel;
    v1Column1: TcxGridDBColumn;
    Label34: TLabel;
    v1Column7: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    KHNameJC: TEdit;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    ToolButton4: TToolButton;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport2: TRMXLSExport;
    CDS_PRT: TClientDataSet;
    v1Column17: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    labMYType: TLabel;
    v1MYType: TcxGridDBColumn;
    CheckBox1: TCheckBox;
    Button2: TButton;
    v1MYMDMoney: TcxGridDBColumn;
    v1JCDanWeiJC: TcxGridDBColumn;
    Label3: TLabel;
    JCDanWeiJC: TEdit;
    Button1: TButton;
    Label4: TLabel;
    filler: TEdit;
    v1filler: TcxGridDBColumn;
    ODPat: TOpenDialog;
    IdFTP1: TIdFTP;
    PopupMenu2: TPopupMenu;
    MenuItem1: TMenuItem;
    N3: TMenuItem;
    MenuItem2: TMenuItem;
    N4: TMenuItem;
    Label2: TLabel;
    Label1: TLabel;
    MYName: TEdit;
    Note: TEdit;
    Button3: TButton;
    ImageList1: TImageList;
    v1RKNo: TcxGridDBColumn;
    v1editer: TcxGridDBColumn;
    KHNo: TEdit;
    JCKHNo: TEdit;
    v1GFOrderNo: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    Label5: TLabel;
    CGName: TEdit;
    v1MYMF: TcxGridDBColumn;
    v1MYKZ: TcxGridDBColumn;
    v1MYName: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure CustomerNoNameChange(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ZJStatusChange(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure Tv1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    canshu1:string;
    DQdate:TDateTime;
    procedure InitGrid();
    procedure InitForm();
    function  DelData():Boolean;
    procedure Initimage();
    { Private declarations }
  public
    FFInt,FCloth:Integer;

    { Public declarations }
  end;

var
  frmMCGRKList_CX: TfrmMCGRKList_CX;

implementation
uses
  U_DataLink,U_RTFun, U_QCRKInPut,U_ZDYHelp,U_LLRKInPut,U_GYSList,U_LLRKInPutMH_MCG,
  U_LLRKInPutMH,U_LLRKInPutX,U_LLRKInPut_CG,U_LLRKInPutMH_CG,U_BPZdy_LRM;

{$R *.dfm}

procedure TfrmMCGRKList_CX.FormDestroy(Sender: TObject);
begin
  frmMCGRKList_CX:=nil;
end;

procedure TfrmMCGRKList_CX.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmMCGRKList_CX.FormCreate(Sender: TObject);
begin
  cxgrid1.Align:=alClient;
  canshu1:=Trim(DParameters1);
end;

procedure TfrmMCGRKList_CX.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('棉采购入库查询',Tv1,'贸易生产管理');
  Close;
end;

procedure TfrmMCGRKList_CX.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      sql.add(',IFFZ=(select Count(B.WBID) from TP_File B where B.WBID=A.RKNo and B.TFType=''采购棉'')');
      sql.Add(',KHNameJC=(select Top 1 B.KHNameJC from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.KHName)');
      sql.Add(',JCDanWeiJC=(select Top 1 B.KHNameJC from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.JCDanWei)');
      sql.Add(',KHNo=(select Top 1 B.KHNo from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.KHName)');
      sql.Add(',JCKHNo=(select Top 1 B.KHNo from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.JCDanWei)');
      sql.Add(' from CK_MYSC_CR A  ');
      sql.Add(' where 1=1 ');
      if CheckBox1.Checked=False then
      begin
        sql.Add(' and A.CRTime>='''+Trim(FormatDateTime('yyyy-MM-dd',now))+'''');
        sql.Add(' and A.CRTime<'''+Trim(FormatDateTime('yyyy-MM-dd',now+1))+'''');
        BegDate.Visible:=false;
        EndDate.Visible:=false;
      end
      else
      begin
        sql.Add(' and A.CRTime>='''+Trim(FormatDateTime('yyyy-MM-dd',BegDate.Date))+'''');
        sql.Add(' and A.CRTime<'''+Trim(FormatDateTime('yyyy-MM-dd',EndDate.Date+1))+'''');
        BegDate.Visible:=true;
        EndDate.Visible:=true;
      end;
      sql.Add(' and isnull(CRType,'''')=''采购入库'' ');
      SQL.Add(' and isnull(MYType,'''')=''采购棉''');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,Order_Main);
    SInitCDSData20(ADOQueryMain,Order_Main);
    TBFind.Click;
  finally
    ADOQueryMain.EnableControls;
  end;
end;


procedure TfrmMCGRKList_CX.InitForm();
begin
  BegDate.Date:=SGetServerDateMBeg(ADOQueryTemp);
  EndDate.Date:=SGetServerDate(ADOQueryTemp);
  ReadCxGrid('棉采购入库查询',Tv1,'贸易生产管理');
  InitGrid();
end;

procedure TfrmMCGRKList_CX.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

function TfrmMCGRKList_CX.DelData():Boolean;
begin
  try
    Result:=false;
    ADOQueryCmd.Connection.BeginTrans;
    Order_Main.DisableControls;
    with Order_Main do
    begin
      //First;
     // while Order_Main.Locate('SSel',True,[]) do
      begin
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add(' delete from YS_Money_CR where YFTypeId in (select B.MYID ');
          SQL.Add(' from CK_MYSC_CR B where B.RKNO='''+trim(Order_Main.fieldbyname('RKNO').AsString)+''') ');
          sql.Add(' delete from TP_File where WBID='''+trim(Order_Main.fieldbyname('RKNO').AsString)+''' ');
          sql.Add(' and TFType=''采购棉''');
          sql.Add(' insert into CK_MYSC_CR_Log  ');
          sql.Add(' select * from CK_MYSC_CR where RKNO='''+Trim(Order_Main.fieldbyname('RKNO').AsString)+'''');
          sql.Add(' UPdate CK_MYSC_CR_Log Set DelTime=getdate(),DelerCode='''+Trim(DCode)+''',Deler='''+Trim(DName)+'''');
          sql.Add(' where RKNO='''+Trim(Order_Main.fieldbyname('RKNO').AsString)+'''');
          sql.Add(' Delete CK_MYSC_CR  where RKNO='''+Trim(Order_Main.fieldbyname('RKNO').AsString)+'''');
          ExecSQL;
        end;
        Order_Main.Delete;
      end;
    end;
    Order_Main.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Result:=False;
    Application.MessageBox('数据删除异常！','提示',0);
  end;
end;

procedure TfrmMCGRKList_CX.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  TcxGridToExcel(Self.Caption,cxGrid1);
end;

procedure TfrmMCGRKList_CX.TBRafreshClick(Sender: TObject);
begin
  InitGrid();

end;

procedure TfrmMCGRKList_CX.FormShow(Sender: TObject);
begin
  InitForm();
end;

procedure TfrmMCGRKList_CX.CheckBox1Click(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmMCGRKList_CX.CheckBox2Click(Sender: TObject);
begin
  TBRafresh.Click;
end;

procedure TfrmMCGRKList_CX.ToolButton1Click(Sender: TObject);
begin
  try
    frmLLRKInPutMH_MCG:=TfrmLLRKInPutMH_MCG.Create(Application);
    with frmLLRKInPutMH_MCG do
    begin
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('RKNo').AsString);
      FMYType:=Trim(Self.Order_Main.fieldbyname('MYType').AsString);
      FMYTypeFlag:=Trim(Self.Order_Main.fieldbyname('MYTypeFlag').AsString);
      TBSave.Visible:=False;
      labMYType.Caption:='(棉)采购';
      if ShowModal=1 then
      begin
        
      end;
    end;
  finally
    frmLLRKInPutMH_MCG.Free;
  end;
end;

procedure TfrmMCGRKList_CX.CustomerNoNameChange(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmMCGRKList_CX.N2Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  if Trim(DParameters1)<>'高权限' then
  begin
    if Order_Main.FieldByName('filltime').AsDateTime+1<Now then
    begin
      application.MessageBox('超过一天不能删除','提示');
      Exit;
    end;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from YS_Money_CR A where A.YFTypeId in (select B.MYID ');
    SQL.Add(' from CK_MYSC_CR B where B.RKNO='''+trim(Order_Main.fieldbyname('RKNO').AsString)+''')');
    sql.Add(' and (isnull(ChkerP,'''')<>'''' ');
    sql.Add(' or isnull(ChkerQ,'''')<>'''') ');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=false then
  begin
    Application.MessageBox('应付款已审核,不能删除','提示');
    exit;
  end;
  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  if DelData() then
  begin
    //Order_Main.Delete;
  end;
end;

procedure TfrmMCGRKList_CX.N1Click(Sender: TObject);
var
  FFMYType:String;
begin
  if Order_Main.IsEmpty then Exit;
  if Trim(DParameters1)<>'高权限' then
  begin
    if Order_Main.FieldByName('CRTime').AsDateTime+1<Now then
    begin
      application.MessageBox('超过一天不能修改','提示');
      Exit;
    end;
  end;
  try
    frmLLRKInPutMH_MCG:=TfrmLLRKInPutMH_MCG.Create(Application);
    with frmLLRKInPutMH_MCG do
    begin
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('RKNo').AsString);
      FMYType:=Trim(Self.Order_Main.fieldbyname('MYType').AsString);
      FMYTypeFlag:=Trim(Self.Order_Main.fieldbyname('MYTypeFlag').AsString);
      labMYType.Caption:='(棉)采购';
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPutMH_MCG.Free;
  end;
end;

procedure TfrmMCGRKList_CX.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmMCGRKList_CX.ZJStatusChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmMCGRKList_CX.ToolButton4Click(Sender: TObject);
var
  fPrintFile:string;
begin
  if Order_Main.IsEmpty then Exit;
  if Trim(Order_Main.fieldbyname('Chker').AsString)='' then exit;
  fPrintFile:=ExtractFilePath(Application.ExeName)+'Report\检测报告.rmf';
  RMXLSExport2:= TRMXLSExport.Create(RMXLSExport2);
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from Test_Report where TRId='''+Trim(Order_Main.fieldbyname('TRId').AsString)+'''');
    Open;
  end;
  SCreateCDS20(ADOQueryTemp,CDS_PRT);
  SInitCDSData20(ADOQueryTemp,CDS_PRT);
  if FileExists(fPrintFile) then
  begin
    //RMVariables['OrderUnit']:=Order_Main.fieldbyname('OrderUnit').Value;
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end  else
  begin
    Application.MessageBox(PChar('没有找'+ExtractFilePath(Application.ExeName)+'Report\检测报告.rmf'),'提示',0);
  end;
end;

procedure TfrmMCGRKList_CX.Tv1DblClick(Sender: TObject);
begin
  ModalResult:=1;
end;

procedure TfrmMCGRKList_CX.Button2Click(Sender: TObject);
begin
  try
    frmGYSList:=TfrmGYSList.Create(Application);
    with frmGYSList do
    begin
      KHType.Text:='棉厂';
      KHType.TxtCode:='棉厂';
      if ShowModal=1 then
      begin
        Self.KHNameJC.Text:=Trim(frmGYSList.Order_Main.fieldbyname('KHNameJC').AsString);
        TBFind.Click;
      end;
    end;
  finally
    frmGYSList.Free;
  end;
end;

procedure TfrmMCGRKList_CX.Button1Click(Sender: TObject);
begin
  try
    frmGYSList:=TfrmGYSList.Create(Application);
    with frmGYSList do
    begin
      KHType.Text:='绣花厂';
      KHType.TxtCode:='绣花厂';
      if ShowModal=1 then
      begin
        Self.JCDanWeiJC.Text:=Trim(frmGYSList.Order_Main.fieldbyname('KHNameJC').AsString);
        TBFind.Click;
      end;
    end;
  finally
    frmGYSList.Free;
  end;
end;

procedure TfrmMCGRKList_CX.Button3Click(Sender: TObject);
begin
  frmBPZDY_LRM:=TfrmBPZDY_LRM.create(self);
  with frmBPZDY_LRM do
  begin
    flag:='MName';
    flagName:='棉';
    ViewFlag:=true;
    Panel4.Align:=alClient;
    ToolBar3.Visible:=false;
    Button1.Visible:=False;
    if ShowModal=1 then
    begin
      MYName.text:=Trim(ClientDataSet1.fieldbyname('BPName').AsString);
    end;
    free;
  end;
end;

procedure TfrmMCGRKList_CX.Initimage();
begin
 
end;

end.
